package com.gxzc.zen.common.util

import com.gxzc.zen.common.properties.UploadProperties
import org.apache.commons.io.FilenameUtils
import java.io.File
import java.io.FileInputStream
import java.nio.ByteBuffer

/**
 * 文件工具类
 * @author NorthLan
 * @date 2018/5/24
 * @url https://noahlan.com
 */
object FileUtil {

    private var uploadProperties = SpringContextHolder.getBean(UploadProperties::class.java)
        get() {
            if (field == null) {
                field = SpringContextHolder.getBean(UploadProperties::class.java)
            }
            return field
        }

    /**
     * 获取 文件首尾chunk+lastModifiedTime 拼接起来的md5
     */
    fun md5HeadTail(path: String, chunkSize: Int?): String {
        val file = File(path)
        return transientMd5HeadTail(file, chunkSize)
    }

    /**
     * 获取 文件首尾chunk+lastModifiedTime 拼接起来的md5
     */
    fun md5HeadTail(file: File, chunkSize: Int?): String {
        return transientMd5HeadTail(file, chunkSize)
    }

    private fun transientMd5HeadTail(file: File, size: Int?): String {
        var chunkSize = size
        if (chunkSize == null) {
            chunkSize = uploadProperties!!.chunkSize!!.toInt()
        }
        val fc = FileInputStream(file).channel
        val buffer = ByteBuffer.allocate(chunkSize)
        val fileSize = fc.size()
        val chunks = Math.ceil(1.0 * fileSize / chunkSize).toInt() // 分块总数

        var currentPos = 0 * chunkSize * 1L

        var readLength: Int
        readLength = fc.read(buffer, currentPos)
        if (readLength != -1) {
            val byte = ByteArray(readLength)
            buffer.flip()
            buffer.get(byte)
            buffer.clear()
            // 第一块读完
            currentPos = (chunks - 1) * chunkSize * 1L
            if (currentPos > 0) {
                readLength = fc.read(buffer, currentPos)
                return if (readLength != -1) {
                    val byte2 = ByteArray(readLength)
                    buffer.flip()
                    buffer.get(byte2)
                    buffer.clear()
                    val retBuffer = ByteBuffer.allocate(byte.size + byte2.size + 8) // 8 为long占用字节数
                    retBuffer.put(byte)
                    retBuffer.put(byte2)

                    val timeByteArray = ByteBuffer.allocate(8).putLong(file.lastModified()).array()
                    timeByteArray.reverse()

                    retBuffer.put(timeByteArray)
                    //
                    MD5Util.encodeMd5(retBuffer.array())
                } else {
                    ""
                }
            } else {
                val retBuffer = ByteBuffer.allocate(byte.size + 8) // 8 为long占用字节数
                retBuffer.put(byte)

                val timeByteArray = ByteBuffer.allocate(8).putLong(file.lastModified()).array()
                timeByteArray.reverse()

                retBuffer.put(timeByteArray)
                //
                return MD5Util.encodeMd5(retBuffer.array())
            }
        } else {
            return ""
        }
    }
}